// C Header File
// Created 7/23/2003; 10:47:30 PM

void LoadDoors(FATCONFIG *fc)
{
	short a;
	short i = 0;

	for(a=0;a<4096;a++)
	{
		short type=-1;
		TEXCONFIG *tex,*sidetex=&textures[DOORSIDETEXTURE];
		char c = fc->map_data[a];
		char d = objectmap[a];
		if(c==WOLF_DOOR_HORIZONTAL||c==DOOR_GOLD_KEY_HORIZONTAL||c==DOOR_SILVER_KEY_HORIZONTAL)
			type = DOOR_HORIZONTAL;
		else if(c==WOLF_DOOR_VERTICAL||c==DOOR_GOLD_KEY_VERTICAL||c==DOOR_SILVER_KEY_VERTICAL)
			type = DOOR_VERTICAL;
		else if(d==SECRET_DOOR) type=PWALL;

		if(type!=-1)
		{
			if(c==WOLF_DOOR_HORIZONTAL||c==WOLF_DOOR_VERTICAL)
			{
				tex=&textures[DOORTEXTURE];
			}
			else if(type!=PWALL)
			{
				tex=&textures[DOORKEYTEXTURE];
			}
			else //PWALL
			{
				tex=&textures[c-1];
				sidetex=NULL;
			}

			FAT_AddDoor(a%64,a/64,type,DOOR_CLOSED,0,tex,sidetex,(void*)(doordata+i));
			if(type==PWALL) objectmap[a] = fc->map_data[a];
			else doordata[i].lock = (c-WOLF_DOOR_VERTICAL)/2;
			fc->map_data[a] = CLOSED_DOOR_TILE;
			i++;
		}
	}
}

////////// (ALMOST) ORIGINAL WOLF CODE
/*
=====================
=
= OpenDoor
=
=====================
*/

void OpenDoor (FATDOOR *curdoor)
{
	if (curdoor->state == DOOR_OPEN)
		((DoorStruct*)(curdoor->clientdata))->tics = 0;			// reset open time
	else
		curdoor->state = DOOR_OPENING;	// start it opening
}


/*
=====================
=
= CloseDoor
=
=====================
*/

void CloseDoor (FATCONFIG *fc, FATDOOR *curdoor)
{
	short	tilex,tiley;
	//objtype *check;

//
// don't close on anything solid
//
	tilex = curdoor->xtile;
	tiley = curdoor->ytile;

	if (objectmap[tilex+(tiley<<6)])
		return;

	if (player->tilex == tilex && player->tiley == tiley)
		return;

/*	if (curdoor->type==DOOR_VERTICAL)
	{
		if ( player->tiley == tiley )
		{
			if ( ((player->x+MINDIST) >>TILESHIFT) == tilex )
				return;
			if ( ((player->x-MINDIST) >>TILESHIFT) == tilex )
				return;
		}
		check = actorat[tilex-1][tiley];
		if (check && ((check->x+MINDIST) >> TILESHIFT) == tilex )
			return;
		check = actorat[tilex+1][tiley];
		if (check && ((check->x-MINDIST) >> TILESHIFT) == tilex )
			return;
	}
	else if (!doorobjlist[door].vertical)
	{
		if (player->tilex == tilex)
		{
			if ( ((player->y+MINDIST) >>TILESHIFT) == tiley )
				return;
			if ( ((player->y-MINDIST) >>TILESHIFT) == tiley )
				return;
		}
		check = actorat[tilex][tiley-1];
		if (check && ((check->y+MINDIST) >> TILESHIFT) == tiley )
			return;
		check = actorat[tilex][tiley+1];
		if (check && ((check->y-MINDIST) >> TILESHIFT) == tiley )
			return;
	}
*/

/*//
// play door sound if in a connected area
//
	area = *(mapsegs[0] + farmapylookup[doorobjlist[door].tiley]
			+doorobjlist[door].tilex)-AREATILE;
	if (areabyplayer[area])
	{
		PlaySoundLocTile(CLOSEDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley);	// JAB
	}*/

	curdoor->state = DOOR_CLOSING;
	fc->map_data[tilex+(tiley<<6)]=CLOSED_DOOR_TILE;
}



/*
=====================
=
= OperateDoor
=
= The player wants to change the door's direction
=
=====================
*/

void OperateDoor (FATCONFIG *fc, FATDOOR *curdoor)
{
	/*short	lock;

	lock = doorobjlist[door].lock;
	if (lock >= dr_lock1 && lock <= dr_lock4)
	{
		if ( ! (gamestate.keys & (1 << (lock-dr_lock1) ) ) )
		{
			SD_PlaySound (NOWAYSND);		// locked
			return;
		}
	}*/

	switch (curdoor->state)
	{
	case DOOR_CLOSED:
	case DOOR_CLOSING:
		OpenDoor (curdoor);
		break;
	case DOOR_OPEN:
	case DOOR_OPENING:
		CloseDoor (fc,curdoor);
		break;
	}
}


//===========================================================================

/*
===============
=
= DoorOpen
=
= Close the door after three seconds
=
===============
*/

void DoorOpen (FATCONFIG *fc, FATDOOR *curdoor)
{
	if ( (((DoorStruct*)(curdoor->clientdata)))->tics++ >= OPENTICS)
		CloseDoor (fc,curdoor);
}



/*
===============
=
= DoorOpening
=
===============
*/

void DoorOpening (FATCONFIG *fc, FATDOOR *curdoor)
{
	short		area1,area2;
  char *loc = fc->map_data+(curdoor->ytile<<6)+curdoor->xtile;

	if (!curdoor->position)
	{
	//
	// door is just starting to open, so connect the areas
	//
  	if(curdoor->type==DOOR_VERTICAL)
  	{
  		area1 = *(loc+1);
  		area2 = *(loc-1);
  	}
  	else
  	{
  		area1 = *(loc+fc->map_width);
  		area2 = *(loc-fc->map_width);
  	}
  	area1 = TileToArea(area1);
  	area2 = TileToArea(area2);

  		areaconnect[area1][area2]++;
			areaconnect[area2][area1]++;
			ConnectAreas ();
			ChangeSpriteSet(fc);
		/*if (areabyplayer[area1])
		{
			PlaySoundLocTile(OPENDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley);	// JAB
		}*/
	}

//
// slide the door
//
	curdoor->position += 4;
	if (curdoor->position >= 64)
	{
	//
	// door is all the way open
	//
		curdoor->position = 64;
		(((DoorStruct*)(curdoor->clientdata)))->tics = 0;
		curdoor->state = DOOR_OPEN;
		*loc = OPEN_DOOR_TILE;
		//actorat[doorobjlist[door].tilex][doorobjlist[door].tiley] = 0;
	}
}


/*
===============
=
= DoorClosing
=
===============
*/
short ValidMove(FATCONFIG* fc, short x, short y);
void DoorClosing (FATCONFIG *fc, FATDOOR *curdoor)
{
	short area1,area2;
	short tilex,tiley;

	tilex = curdoor->xtile;
	tiley = curdoor->ytile;

	if (/* ((unsigned)actorat[tilex][tiley] != (door | 0x80))
	|| */(abs(player->tilex-tilex)<2 && abs(player->tiley-tiley)<2) )
	{			// something got inside the door
		if(!ValidMove(fc,fc->cam_xpos,fc->cam_ypos))
		{
		OpenDoor (curdoor);
		return;			
		}
	};

//
// slide the door
//
	curdoor->position -= 4;
	if (curdoor->position <= 0)
	{
	//
	// door is closed all the way, so disconnect the areas
	//
  	char *loc = fc->map_data+(tiley<<6)+tilex;
  	if(curdoor->type==DOOR_VERTICAL)
  	{
  		area1 = *(loc+1);
  		area2 = *(loc-1);
  	}
  	else
  	{
  		area1 = *(loc+fc->map_width);
  		area2 = *(loc-fc->map_width);
  	}
  	area1 = TileToArea(area1);
  	area2 = TileToArea(area2);

		curdoor->position = 0;

		curdoor->state = DOOR_CLOSED;



  		areaconnect[area1][area2]--;
			areaconnect[area2][area1]--;
			ConnectAreas ();
			ChangeSpriteSet(fc);
	}

}


/*
=====================
=
= MoveDoors
=
= Called from PlayLoop
=
=====================
*/

void MoveDoors (FATCONFIG *fc)
{
	short		door;
	FATDOOR *curdoor = FAT_GetDoorsArray();

	/*if (gamestate.victoryflag)		// don't move door during victory sequence
		return;*/

	for (door = 0 ; door < FAT_GetNrDoors(); door++,curdoor++)
		switch (curdoor->state)
		{
		case DOOR_OPEN:
			DoorOpen (fc,curdoor);
			break;

		case DOOR_OPENING:
			DoorOpening(fc,curdoor);
			break;

		case DOOR_CLOSING:
			DoorClosing(fc,curdoor);
			break;

			//CLOSED: Nothing :-)
		}
}

/*
=============================================================================

						PUSHABLE WALLS

=============================================================================
*/

/*
===============
=
= PushWall
=
===============
*/

void PushWall (FATCONFIG *fc, short checkx, short checky, short dir)
{
	if (pwallstate)
	  return;


	oldtile = objectmap[checkx+(checky<<6)];
	if (!oldtile)
		return;
	objectmap[checkx+(checky<<6)] = 0;

/*	switch (dir)
	{
	case di_north:
		if (actorat[checkx][checky-1])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx][checky-1] =
		tilemap[checkx][checky-1] = oldtile;
		break;

	case di_east:
		if (actorat[checkx+1][checky])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx+1][checky] =
		tilemap[checkx+1][checky] = oldtile;
		break;

	case di_south:
		if (actorat[checkx][checky+1])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx][checky+1] =
		tilemap[checkx][checky+1] = oldtile;
		break;

	case di_west:
		if (actorat[checkx-1][checky])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx-1][checky] =
		tilemap[checkx-1][checky] = oldtile;
		break;
	}*/

	//gamestate.secretcount++;
	pwallx = checkx;
	pwally = checky;
	pwalldir = dir;
	pwallstate = 1;
	pwallpos = 0;
	//tilemap[pwallx][pwally] |= 0xc0;
	fc->map_data[pwallx+(pwally<<6)] = CLOSED_DOOR_TILE;
	//*(mapsegs[1]+farmapylookup[pwally]+pwallx) = 0;	// remove P tile info

	//SD_PlaySound (PUSHWALLSND);
}



/*
=================
=
= MovePWalls
=
=================
*/

void MovePWalls (FATCONFIG *fc)
{
	short		oldblock;
	FATDOOR *curwall = FAT_GetDoor(pwallx,pwally);

	if (!pwallstate)
		return;

	if(!curwall) return;

	//printf_xy(0,0,"%i [%i,%i] ",pwalldir,pwallx,pwally);

	oldblock = pwallstate>>6;

	pwallstate += 2;

	if (pwallstate>>6 != oldblock)
	{
	// block crossed onto a new block
		//oldtile = fc->map_data[pwallx+pwally*64];

		//
		// the tile can now be walked into
		//
		fc->map_data[pwallx+(pwally<<6)] = TileToArea(player->areanumber);
		//(unsigned)actorat[pwallx][pwally] = 0;
		//*(mapsegs[0]+farmapylookup[pwally]+pwallx) = player->areanumber+AREATILE;

		//
		// see if it should be pushed farther
		//
		if (pwallstate>128)
		{
		//
		// the block has been pushed two tiles
		//
			switch (pwalldir)
			{
			case ANGLE_NORTH:
				pwally--;
				break;
			case ANGLE_EAST:
				pwallx++;
				break;
			case ANGLE_SOUTH:
				pwally++;
				break;
			case ANGLE_WEST:
				pwallx--;
				break;
			}
			pwallstate = 0;
			curwall->xtile = pwallx;
			curwall->ytile = pwally;
			fc->map_data[pwallx+(pwally<<6)] = oldtile;
			return;
		}
		else
		{
			switch (pwalldir)
			{
			case ANGLE_NORTH:
				pwally--;
				/*if (actorat[pwallx][pwally-1])
				{
					pwallstate = 0;
					return;
				}
				(unsigned)actorat[pwallx][pwally-1] =
				tilemap[pwallx][pwally-1] = oldtile;*/
				break;

			case ANGLE_EAST:
				pwallx++;
				/*if (actorat[pwallx+1][pwally])
				{
					pwallstate = 0;
					return;
				}
				(unsigned)actorat[pwallx+1][pwally] =
				tilemap[pwallx+1][pwally] = oldtile;*/
				break;

			case ANGLE_SOUTH:
				pwally++;
				/*if (actorat[pwallx][pwally+1])
				{
					pwallstate = 0;
					return;
				}
				(unsigned)actorat[pwallx][pwally+1] =
				tilemap[pwallx][pwally+1] = oldtile;*/
				break;

			case ANGLE_WEST:
				pwallx--;
				/*if (actorat[pwallx-1][pwally])
				{
					pwallstate = 0;
					return;
				}
				(unsigned)actorat[pwallx-1][pwally] =
				tilemap[pwallx-1][pwally] = oldtile;*/
				break;
			}
			curwall->xtile = pwallx;
			curwall->ytile = pwally;
			fc->map_data[pwallx+(pwally<<6)] = CLOSED_DOOR_TILE;
		}
	}


	pwallpos = curwall->position = pwallstate&63;

}
///////////END (Almost) Original Wolf Code

void OpenDoorForPlayer(FATCONFIG *fc)
{
  short tile_x = ((FAT_Cos16384(fc->cam_orientation) >> 8)+fc->cam_xpos)>>6;
  short tile_y = ((FAT_Sin16384(fc->cam_orientation) >> 8)+fc->cam_ypos)>>6;
  FATDOOR *curdoor = FAT_GetDoor(tile_x,tile_y);
  if(curdoor)
  {
		short dir = 0;
		if(fc->cam_orientation>=ANGLE_EAST+ANGLE_045 && fc->cam_orientation<ANGLE_SOUTH+ANGLE_045) dir=ANGLE_SOUTH;
  	if(fc->cam_orientation>=ANGLE_SOUTH+ANGLE_045 && fc->cam_orientation<ANGLE_WEST+ANGLE_045) dir=ANGLE_WEST;
  	if(fc->cam_orientation>=ANGLE_WEST+ANGLE_045 && fc->cam_orientation<ANGLE_NORTH+ANGLE_045) dir=ANGLE_NORTH;
  	if(fc->cam_orientation>=ANGLE_NORTH+ANGLE_045 || fc->cam_orientation<ANGLE_EAST+ANGLE_045) dir=ANGLE_EAST;

  	if(curdoor->type!=PWALL) OperateDoor(fc,curdoor);
  	else PushWall(fc,tile_x,tile_y,((FAT_ClampAngle(fc->cam_orientation+ANGLE_045))/ANGLE_090)*ANGLE_090);
  }
}
